#ifndef HEADER_WCME_TLS_INTERNAL_H
#define HEADER_WCME_TLS_INTERNAL_H

#include <openssl/ssl.h>

#define WCME_IDIOM

/* reduce "__" to "_" to enable debug statements */
#define WCME__DBG_LIBTLS

#define WCME_LIBTLS_VERSION "19.2"

#define WCME_OPENSSL_AFTER_110  (OPENSSL_VERSION_NUMBER > 0x10100000L)
#define WCME_OPENSSL_AFTER_111  (OPENSSL_VERSION_NUMBER > 0x10101000L)
#define WCME_OPENSSL_BEFORE_100 (OPENSSL_VERSION_NUMBER < 0x10000000L)
#define WCME_OPENSSL_BEFORE_110 (OPENSSL_VERSION_NUMBER < 0x10100000L)
#define WCME_OPENSSL_BEFORE_111 (OPENSSL_VERSION_NUMBER < 0x10101000L)
#define WCME_OPENSSL_SINCE_110  (OPENSSL_VERSION_NUMBER >= 0x10100000L)
#define WCME_OPENSSL_SINCE_111  (OPENSSL_VERSION_NUMBER >= 0x10101000L)
#define WCME_OPENSSL_SINCE_120  (OPENSSL_VERSION_NUMBER >= 0x10200000L)

#if WCME_OPENSSL_BEFORE_100 || WCME_OPENSSL_SINCE_120
#error "WCME supports compilation OpenSSL against v1.0.2 and v1.1.n"
#endif

#define WCME_DEFAULT_CA_FILE "/wcme_root/etc/cacert.pem"

#endif /* HEADER_WCME_TLS_INTERNAL_H */
